;--- DESS IRR03 --- Le 08/01/2003 ---
; Alexandre ALAPETITE et Pierre COHADE
;
; Nom du fichier:
;    "NOYAU_AC3.lisp".
;
; Rle du fichier:
;    Ce fichier contient les fonctions du Programme de l'AC3 Modifi (avec Filtre Partial Look Futur).

;nomX est la variable dans la liste LX dont le domaine est en cours d'lagage
(DEFUN FILTRE_PARTIAL_LOOK_FUTUR(LX nomX)
  (PROGN
    (loop for contrainte in (GET_VARIABLE LISTE_CONTRAINTES_FCF nomX) do
      (do ((fin_boucle NIL))
          ((EQUAL fin_boucle T))
        (IF (NULL (EVAL contrainte))
          (IF (NULL (LISTE_VAR_CONTRAINTE_NO_NOMX contrainte nomX))
            (IF (NULL (INC_VALEUR_AND_DEL LX nomX))
              (PROGN
                (SET_FIRST_VALEUR LX nomX)
                (SETF fin_boucle T)
              )
            )
            (IF (NULL (INC_VALEUR_LISTE LX contrainte nomX))
              (PROGN
                (SET_FIRST_VALEUR_LISTE LX contrainte nomX)
                (IF (NULL (INC_VALEUR_AND_DEL LX nomX))
                  (PROGN
                    (SET_FIRST_VALEUR LX nomX)
                    (SETF fin_boucle T)
                  )
                )
              )
            )
          )
          (PROGN
            (SET_FIRST_VALEUR_LISTE LX contrainte nomX)
            (IF (NULL (INC_VALEUR LX nomX))
              (PROGN
                (SET_FIRST_VALEUR LX nomX)
                (SETF fin_boucle T)
              )
            )
          )
        )
      )
    )
    (NOT (NULL (GET_DOMAINE LX nomX)))
  )
)

;Fonction qui sert  initialiser et  lancer l'algorithme du Filtre Partial Look Futur
(DEFUN PROG_FILTRE_PARTIAL_LOOK_FUTUR(LX)
  (LET ((solution_possible T))
    (loop for var in (COPY_PLISTE (LISTE_VARIABLES LX)) do
      (IF (NOT (NULL solution_possible))
        (IF (NULL (FILTRE_PARTIAL_LOOK_FUTUR LX var))
          (SETF solution_possible NIL)
        )
      )
    )
    solution_possible
  )
)
