;--- DESS IRR03 --- Le 05/01/2003 ---
; Alexandre ALAPETITE et Pierre COHADE
;
; Nom du fichier:
;    "main.lisp".
;
; Rle du fichier:
;    Ce fichier est le fichier de commande (le Programme Principal).
;    Il permet d'acqurir les donnes et de lancer le programme de rsolution CSP, AC3 Modifie ou FC.
;    Il fait appel aux fichiers "TRAITEMENT_PLISTE", "INTERFACE_HM", "NOYAU_BT", "NOYAU_CF" et "NOYAU_FC"

;Paramtre qui nous permet de ne plus afficher les dpassements d'allocation mmoire
(SETF extensions:*bytes-consed-between-gcs* '50000000)
(SETF extensions:*gc-verbose* NIL)

;Chargement des diffrents fichiers
(LOAD "TRAITEMENT_PLISTE.LISP")
(LOAD "INTERFACE_HM.LISP")
(LOAD "NOYAU_BT.LISP")
(LOAD "NOYAU_AC3.LISP")
(LOAD "NOYAU_FC.LISP")

;Dfinition d'une PListe "COPY_VARIABLES",
;que l'on utilisera pour lancer plusieurs fois les diffrents algorithmes
(DEFVAR COPY_VARIABLES 'COPY_VARIABLES)

(do ((LEC 0))
    ((EQUAL LEC 1))
    (RECOPIE_PLISTE COPY_VARIABLES VARIABLES)
    (AFFICHE_MENU_PRINCIPAL)
    (CASE (READ T)
      (1 (MENU_DONNEES))
      (2 (LANCE_BT COPY_VARIABLES))
      (3 (LANCE_AC3 COPY_VARIABLES))
      (4 (LANCE_FC COPY_VARIABLES))
      (5 (SETF LEC 1))
    )
)

(format t "~%")
(format t "~%")
(format t "~%")

(quit)
