;--- DESS IRR03 --- Le 27/11/2002 ---
; Alexandre ALAPETITE et Pierre COHADE
;
; Nom du fichier:
;    "NOYAU_BT.lisp".
;
; Rle du fichier:
;    Ce fichier contient les fonctions du Programme du BackTrack (BT).
;

;Variable globale servant  savoir si l'on a trouve une solution pour le BackTrack
(DEFVAR Solution_trouvee_BT NIL)

;Fonction rcursive du BackTrack
(DEFUN R_PROG_BT(LX liste_variables)
  (IF (NULL Solution_trouvee_BT)
    (IF (NULL (EVAL_ALL_CONTRAINTES LX (FIRST liste_variables)))
      (IF (NULL (INC_VALEUR LX (FIRST liste_variables)))
        (PROGN
          (SET_FIRST_VALEUR LX (FIRST liste_variables))
          NIL
        )
        (R_PROG_BT LX liste_variables)
      )
      (COND
        ((NULL (REST liste_variables)) (SETF Solution_trouvee_BT T))
        ((EQUAL (R_PROG_BT LX (REST liste_variables)) T) T)
        ((NULL (INC_VALEUR LX (FIRST liste_variables))) (SET_FIRST_VALEUR LX (FIRST liste_variables)))
        (T (R_PROG_BT LX liste_variables))
      )
    )
  )
)

;Fonction qui sert  initialiser et  lancer l'algorithme du BackTrack
(DEFUN PROG_BT(LX)
  (PROGN
    (SETF Solution_trouvee_BT NIL)
    (R_PROG_BT LX (LISTE_VARIABLES LX))
    Solution_trouvee_BT
  )
)
